#include <stdio.h>
#include <stdarg.h>
#include "io.h"
#include "misc.h"

void SetText(int x,int y, int c,int tr,int time, const char *fmt, ...)
{
	char Buf[512], *s;
	va_list ap;
	int nx=x;
	
	va_start(ap, fmt);	
	#ifdef HAVE_VSNPRINTF
	vsnprintf(Buf, sizeof(Buf)-1, fmt, ap);
	#else
	vsprintf(Buf, fmt, ap);
	#endif
	va_end(ap);
	
	for(s=Buf; *s; s++)
		switch(*s)
		{
			case '\b': x--; break;
			case '\n': y++; /* through */
			case '\r': x=nx; break;
			default:
				SetChar(x++,y,*s, c,tr,time);
		}
}

void Center(int y, int c,int tr,int time, const char *fmt, ...)
{
	char Buf[512], *s;
	va_list ap;
	int nx, x;
	
	va_start(ap, fmt);	
	#ifdef HAVE_VSNPRINTF
	vsnprintf(Buf, sizeof(Buf)-1, fmt, ap);
	#else
	vsprintf(Buf, fmt, ap);
	#endif
	va_end(ap);
	
	s=Buf;
	
GetNx:
	for(x=0; s[x] && s[x]!='\n'; x++);
	x = nx = (41-x) / 2;
	
	for(; *s; s++)
		switch(*s)
		{
			case '\b':
				x--;
				break;
			case '\n':
				y++;
				s++;
				goto GetNx;
				break;
			case '\r':
				x=nx;
				break;
			default:
				SetChar(x++,y,*s, c,tr,time);
		}
}
